<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'report.title' | translate}}
          <span class="float-right"><button [disabled]="add || editStatus" (click)="addReport()" class="btn btn-block btn-primary">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body">
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px" [disabled]="add || editStatus">
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input [(ngModel)]="keywordSearch" type="text" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" type="button" [disabled]="add || editStatus">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <table class="table table-bordered table-sort-icon">
            <thead>
            <tr appSort [(orderBy)]="order.orderBy" [(orderType)]="order.orderType" (orderChange)="changeOder($event)">
              <th appSortBy="name" class="text-center">{{'report.name' | translate}}<fa-icon></fa-icon></th>
              <th appSortBy="period" class="text-center">{{'report.period' | translate}}</th>
              <th appSortBy="account" class="text-center">{{'report.account' | translate}}</th>
              <th appSortBy="mail_sender" class="text-center">{{'report.mail_sender' | translate}}</th>
              <th class="text-center">{{'report.state' | translate}}</th>
              <th class="text-center">{{'report.report_form' | translate}}</th>
              <th class="text-center">{{'common.action' | translate}}</th>
            </tr>
            </thead>
            <tbody>
            <tr *ngFor="let report of reports; let i = index" [formGroup]="reportForm">
<!--              view only-->
              <td *ngIf="!editing[i]">{{report.name}}</td>
              <td *ngIf="!editing[i]">{{report.period}}</td>
              <td *ngIf="!editing[i]">
                <div *ngFor="let account of report.account">
                  {{account}}
                </div>
              </td>
              <td *ngIf="!editing[i]">{{report.mail_sender}}</td>
              <td *ngIf="!editing[i]" class="text-center">
                <span *ngIf="report.state" class="badge badge-success">On</span>
                <span *ngIf="!report.state" class="badge badge-warning">Off</span>
              </td>
              <td *ngIf="!editing[i]" class="text-center card-tooltip">
                <span (click)="disableValue(reportFormTooltipView, i); reportFormTooltipView[i] = !reportFormTooltipView[i]">
                  <i [class]="reportFormTooltipView[i] ? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i>
                </span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="reportFormTooltipView[i]">
                  <div class="tooltip__item" style="width: 500px">
                    <div class="card m-0 scroll-report min-height-report">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="reportFormTooltipView[i] = !reportFormTooltipView[i]">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body scroll-report">
                        {{report.report_form}}
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <td class="text-center" *ngIf="!editing[i]">
                <div class="btn-group">
                  <button type="button"
                          class="btn btn-success btn-sm"
                          [disabled]="add || editStatus"
                          (click)="changeEditStatus(i)">
                    <i class="icon-pencil"></i>
                    <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                  </button>
                  <button type="submit" (click)="delete(deleteModal, i)"
                          [disabled]="add || editStatus"
                          class="btn btn-danger btn-sm">
                    <i class="icon-action-undo"></i>
                    <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                  </button>
                </div>
              </td>
<!--              end view-->

<!--              case for edit inline-->
              <td *ngIf="editing[i]">
                <input class="form-control" [placeholder]="'name'" type="text" formControlName="name">
              </td>
              <td *ngIf="editing[i]">
                <select formControlName="period" class="form-control float-left">
                  <ng-container *ngFor="let period of periods">
                    <option value="{{period.id}}">
                      {{ period.period_name }}
                    </option>
                  </ng-container>
                </select>
              </td>
              <td *ngIf="editing[i]" style="max-width: 20em; width: 15em">
                <app-multiselect
                  name="account"
                  [data]="accounts"
                  [disabled]="false"
                  [settings]="accountSettings"
                  (onSelect)="selectAccount($event)"
                  (onDeSelect)="unselectAccount($event)"
                  [(ngModel)]="selectedAccount"
                  [ngModelOptions]="{standalone: true}"
                >
                </app-multiselect>
              </td>
              <td *ngIf="editing[i]">
                <select
                  class="form-control" formControlName="mail_sender_id">
                  <ng-container *ngFor="let mailsender of mailsenders; let i = index">
                    <option value="{{mailsender.id}}">{{mailsender.email}}</option>
                  </ng-container>
                </select>
              </td>
              <td *ngIf="editing[i]" class="text-center">
                <label class="switch switch-pill switch-success">
                  <input type="checkbox" class="switch-input" checked formControlName="state">
                  <span class="switch-slider"></span>
                </label>
              </td>
              <td *ngIf="editing[i]" class="text-center">
                <span (click)="reportTooltip = !reportTooltip">
                  <i class="fa fa-edit"></i>
                </span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="reportTooltip">
                  <div class="tooltip__item" style="width: 500px">
                    <div class="card m-0 scroll min-height">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="reportTooltip = !reportTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body scroll">
                        <form [formGroup]="reportForm">
                          <div class="row justify-content-center">
                            <quill-editor
                              [bounds]="'self'"
                              [style]="{ height: '300px', margin: '2px' }"
                              formControlName="report_form"
                              [format]="'text'"
                            ></quill-editor>
                          </div>
                        </form>
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <td *ngIf="editing[i]" class="text-center">
                <div class="btn-group">
                <button (click)="editSave(i)"
                        class="btn btn-primary btn-sm">
                  <i class="fa fa-save"></i>
                  <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                </button>
                <button type="button" (click)="editCancel(i)"
                        class="btn btn-danger btn-sm">
                  <i class="icon-action-undo"></i>
                  <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                </button>
                </div>
              </td>
<!--              end edit-->
            </tr>

<!--            add new-->
            <tr *ngIf="add" [formGroup]="reportForm">
              <td>
                <input class="form-control" [placeholder]="'name'" type="text" formControlName="name">
              </td>
              <td>
                <select formControlName="period" class="form-control float-left">
                  <option *ngFor="let i of periods" value="{{i.id}}">
                    {{ i.period_name }}
                  </option>
                </select>
              </td>
              <td style="max-width: 20em; width: 15em">
                <app-multiselect
                  name="account"
                  [data]="accounts"
                  [disabled]="false"
                  [settings]="accountSettings"
                  (onSelect)="selectAccount($event)"
                  (onDeSelect)="unselectAccount($event)"
                >
                </app-multiselect>
              </td>
              <td>
                <select
                  class="form-control" formControlName="mail_sender_id" id="field_report_mail">
                  <ng-container *ngFor="let mailsender of mailsenders; let i = index">
                    <option value="{{mailsender.id}}">{{mailsender.email}}</option>
                  </ng-container>
                </select>
              </td>
              <td class="text-center">
                <label class="switch switch-pill switch-success">
                  <input type="checkbox" class="switch-input" checked formControlName="state">
                  <span class="switch-slider"></span>
                </label>
              </td>
              <td class="text-center">
                <span (click)="reportTooltip = !reportTooltip">
                  <i class="fa fa-edit"></i>
                </span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="reportTooltip">
                  <div class="tooltip__item" style="width: 500px">
                    <div class="card m-0 scroll min-height">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="reportTooltip = !reportTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body scroll">
                        <form [formGroup]="reportForm">
                          <div class="row justify-content-center">
                            <quill-editor
                              [bounds]="'self'"
                              [style]="{ height: '300px', margin: '2px' }"
                              formControlName="report_form"
                              [format]="'text'"
                            ></quill-editor>
                          </div>
                        </form>
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <td class="text-center">
                <div class="btn-group">
                <button (click)="save()"
                        class="btn btn-primary btn-sm">
                  <i class="fa fa-save"></i>
                  <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                </button>
                <button type="button" (click)="add = !add"
                        class="btn btn-danger btn-sm">
                  <i class="icon-action-undo"></i>
                  <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                </button>
                </div>
              </td>
            </tr>
            </tbody>
          </table>
          <div class="row justify-content-between" *ngIf="reports.length > 0">
            <span class="col-6">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + reports.length),
              total: paging.total
            } }}</span>
            <div class="col-6">
              <ngb-pagination class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              [disabled]="editStatus"
                              (pageChange)="loadPage(paging.page)" [disabled]="add || editStatus">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="reports.length === 0" class="text-center">
            <span>There is no record!</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'report.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'report.delete_popup.message' | translate: {name : selectedReport.name} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('delete')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>
<ng-template #report_form let-modal>
  <div class="modal-header">
    <h4 class="modal-title">{{'report.add.report_form' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form [formGroup]="reportForm">
      <div class="row justify-content-center">
        <quill-editor
          [bounds]="'self'"
          [style]="{ height: '300px', margin: '2px' }"
          formControlName="report_form"
          [format]="'text'"
        ></quill-editor>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-primary"
            (click)="modal.close('Save click')"
            [disabled]="!reportForm.get('report_form').valid">
      {{'common.save' | translate}}
    </button>
  </div>
</ng-template>
